// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "kodpol.h"
#include "vykazy1Doc.h"
#include "Vyp2View.h"
#include "Vyp1View.h"
#include "Vyp3View.h"
#include "Vyp4View.h"
#include "vykazy1.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame
//musi byt dymanmic, kvuli Iskindof metode
IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_ZOBRAZ_OSTATN, OnZobrazOstatn)
	ON_COMMAND(IDM_ZOBRAZ_PROTETIKA, OnZobrazProtetika)
	ON_COMMAND(IDM_ZOBRAZ_STANDART, OnZobrazStandart)
	ON_UPDATE_COMMAND_UI(IDM_ZOBRAZ_OSTATN, OnUpdateZobrazOstatn)
	ON_UPDATE_COMMAND_UI(IDM_ZOBRAZ_STANDART, OnUpdateZobrazStandart)
	ON_UPDATE_COMMAND_UI(IDM_ZOBRAZ_PROTETIKA, OnUpdateZobrazProtetika)
	ON_COMMAND(ID_VYPIS, OnVypis)
	ON_UPDATE_COMMAND_UI(ID_VYPIS, OnUpdateVypis)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


extern CVykazy1App theApp; 

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

//vytvori se hlavni MDI ramec 
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::CreateOrActivateFrame(CDocTemplate* pTemplate,
		CRuntimeClass* pViewClass)
/* Jeslize je jedno z views (pViewClass) jiz vytvorene,
aktivuj ho, pokud ne, tak ho vytvor pro document
*/
{
	//vrati pointer na aktivni MDIChild
	CMDIChildWnd* pMDIActive = MDIGetActive();
	
	//makro assert pri podmince=0 napise message a ukonci program
	ASSERT(pMDIActive != NULL);
	//ukazatel na dokument 
	CDocument* pDoc = pMDIActive->GetActiveDocument();
	ASSERT(pDoc != NULL);

	CView* pView;
	//da pozici prvniho view ze vsech views, ktere patri dokumentu
	POSITION pos = pDoc->GetFirstViewPosition();
	while (pos != NULL)
	{
		pView = pDoc->GetNextView(pos);
		//jeslize je toto view to, ktere chceme aktivovat,
		//tak ho aktivuj
		if (pView->IsKindOf(pViewClass))
		{
			pView->GetParentFrame()->ActivateFrame();
			return;
		}
	}
    
	//vytvoreni noveho child framu 
	CMDIChildWnd* pNewFrame
		= (CMDIChildWnd*)(pTemplate->CreateNewFrame(pDoc, NULL));
	if (pNewFrame == NULL)
		return;     // not created
	ASSERT_KINDOF(CMDIChildWnd, pNewFrame);
	pTemplate->InitialUpdateFrame(pNewFrame, pDoc);
}





void CMainFrame::OnZobrazOstatn() 
{
	// TODO: Add your command handler code here
	CreateOrActivateFrame(theApp.m_pVyk3ViewTemplate,
		RUNTIME_CLASS(CVyp3View));
}

	

void CMainFrame::OnZobrazProtetika() 
{
	// TODO: Add your command handler code here
	CreateOrActivateFrame(theApp.m_pVyk2ViewTemplate,
		RUNTIME_CLASS(CVyp2View));
 	
}

void CMainFrame::OnZobrazStandart() 
{
	// TODO: Add your command handler code here
	CreateOrActivateFrame(theApp.m_pVyk1ViewTemplate,
		RUNTIME_CLASS(CVyp1View));
	
}

void CMainFrame::OnUpdateZobrazOstatn(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
    CMDIChildWnd *pChild = (CMDIChildWnd *)GetActiveFrame();
    CVykazy1Doc* pDoc = (CVykazy1Doc*)pChild->GetActiveDocument();
	if (pDoc==NULL)
      pCmdUI->Enable(false);
}

void CMainFrame::OnUpdateZobrazStandart(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
 	OnUpdateZobrazOstatn(pCmdUI);
}

void CMainFrame::OnUpdateZobrazProtetika(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
 	OnUpdateZobrazOstatn(pCmdUI);
}

void CMainFrame::OnVypis() 
{
	// TODO: Add your command handler code here
	CreateOrActivateFrame(theApp.m_pVyk4ViewTemplate,
		RUNTIME_CLASS(CVyp4View));
}

void CMainFrame::OnUpdateVypis(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
 	OnUpdateZobrazOstatn(pCmdUI);
}
